Index: /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5074)
+++ /branches/2014/dev_r4650_UKMO7_STARTHOUR/NEMOGCM/TOOLS/SIREN/src/variable.f90	(revision 5075)
@@ -4843,160 +5374,22 @@
       !----------------------------------------------------------------
 
-      CALL logger_info( &
-      &  " ADD DIM: add dimension "//TRIM(td_dim%c_name)//&
-      &  ", short name "//TRIM(td_dim%c_sname)//&
-      &  ", length "//TRIM(fct_str(td_dim%i_len))//&
-      &  ", in variable "//TRIM(td_var%c_name) )
-
-      ! if dimension order already changed
-      IF( ANY(td_var%t_dim(:)%i_xyzt2 /= 0 ) )THEN
-         ! unordered dimension structure
-         CALL dim_unorder(td_var%t_dim(:))
-      ENDIF
-
-      ! search unused dimension
-      DO ji=1,ip_maxdim
-         IF( .NOT. td_var%t_dim(ji)%l_use )THEN
-            ! add new dimension
-            td_var%t_dim(ji)=td_dim
-            td_var%t_dim(ji)%i_id=ji
-            !!td_var%t_dim(ji)%l_use=.TRUE.
-            IF( td_var%t_dim(ji)%l_use )THEN
-               ! update number of attribute
-               td_var%i_ndim=td_var%i_ndim+1
-            ENDIF
-            EXIT
-         ENDIF
+      DO ji=1,SIZE(td_var(:))
+         CALL var_print(td_var(ji))
       ENDDO
 
-      ! reorder dimension to ('x','y','z','t')
-      CALL dim_reorder(td_var%t_dim(:))
-
-   END SUBROUTINE var__add_dim
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine delete a dimension structure in a variable 
-   !> structure.<br/>
-   !
-   !> @warning delete variable value too
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dim : dimension structure
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var_del_dim(td_var, td_dim)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TVAR), INTENT(INOUT) :: td_var
-      TYPE(TDIM), INTENT(IN) :: td_dim
-
-      ! local variable
-      INTEGER(i4) :: il_dimid
-      TYPE(TDIM)  :: tl_dim ! empty dimension structure
-
-      INTEGER(i4), DIMENSION(ip_maxdim) :: il_shape
-
-      !----------------------------------------------------------------
-      IF( td_var%i_ndim <= 4 )THEN
-
-         ! check if dimension already in variable structure
-         il_dimid=dim_get_id( td_var%t_dim(:), td_dim%c_name, td_dim%c_sname )
-         IF( il_dimid == 0 )THEN
-
-            CALL logger_warn( &
-            &  " DEL DIM: no dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", in variable "//TRIM(td_var%c_name) )
-
-         ELSE
-
-            CALL logger_debug( &
-            &  " DEL DIM: delete dimension "//TRIM(td_dim%c_name)//&
-            &  ", short name "//TRIM(td_dim%c_sname)//&
-            &  ", in variable "//TRIM(td_var%c_name)//&
-            &  " id "//TRIM(fct_str(il_dimid)) )
-
-            ! replace dimension by empty one
-            td_var%t_dim(il_dimid)=tl_dim
-
-            ! update number of dimension
-            td_var%i_ndim=td_var%i_ndim-1
-
-            IF( ASSOCIATED(td_var%d_value) )THEN
-               il_shape(:)=SHAPE(td_var%d_value(:,:,:,:))
-               IF(il_shape(il_dimid)/=td_dim%i_len)THEN
-                  CALL logger_warn("VAR DEL DIM: remove value of variable "//&
-                  &  TRIM(td_var%c_name) )
-                  CALL var_del_value(td_var)
-               ENDIF
-            ENDIF
-
-            ! reorder dimension to ('x','y','z','t')
-            CALL dim_reorder(td_var%t_dim)
-
-         ENDIF
-      ELSE
-         CALL logger_error( &
-         &  " DEL DIM: too much dimension in variable "//&
-         &  TRIM(td_var%c_name)//" ("//TRIM(fct_str(td_var%i_ndim))//")")
-      ENDIF
-
-   END SUBROUTINE var_del_dim
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine move a dimension structure 
-   !> in variable structure.
-   !>
-   !> @warning 
-   !> - dimension order could be changed
-   !> - delete variable value 
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] td_dim : dimension structure
-   !> @todo
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var_move_dim(td_var, td_dim)
-      IMPLICIT NONE
-      ! Argument      
-      TYPE(TVAR), INTENT(INOUT) :: td_var
-      TYPE(TDIM), INTENT(IN)    :: td_dim
-
-      ! local variable
-      TYPE(TDIM) :: tl_dim
-      !----------------------------------------------------------------
-
-      ! copy dimension
-      tl_dim=td_dim
-
-      ! remove dimension with same name
-      CALL var_del_dim(td_var, tl_dim)
-
-      ! add new dimension
-      CALL var_add_dim(td_var, tl_dim)
-
-   END SUBROUTINE var_move_dim
-   !> @endcode    
+   END SUBROUTINE var__print_arr
    !-------------------------------------------------------------------
    !> @brief This subroutine print variable information.</br/>
+   !> @details
    !> If ld_more is TRUE (default), print information about variable dimensions
    !> and variable attributes.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_var : variable structure
-   !> @param[in] ld_more : print more infomration about variable
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var_print(td_var, ld_more)
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_var    variable structure
+   !> @param[in] ld_more   print more infomration about variable
+   !-------------------------------------------------------------------
+   SUBROUTINE var__print_unit(td_var, ld_more)
       IMPLICIT NONE
 
@@ -5039,6 +5432,21 @@
       END SELECT      
 
+      WRITE(*,'((/a,a),4(/3x,a,a),4(/3x,a,i3),&
+      &         (/3x,a,a),3(/3x,a,ES12.4))')&
+      &        " Variable : ",TRIM(td_var%c_name),    &
+      &        " standard name : ",TRIM(td_var%c_stdname), &
+      &        " long name     : ",TRIM(td_var%c_longname), &
+      &        " units         : ",TRIM(td_var%c_units),   &
+      &        " point         : ",TRIM(td_var%c_point),   &
+      &        " id            : ",td_var%i_id,            &
+      &        " rec           : ",td_var%i_rec,           &
+      &        " ndim          : ",td_var%i_ndim,          &
+      &        " natt          : ",td_var%i_natt,          &
+      &        " type          : ",TRIM(cl_type),          &
+      &        " scale factor  : ",td_var%d_scf,           &
+      &        " add offset    : ",td_var%d_ofs,           &
+      &        " _FillValue    : ",td_var%d_fill
+
       IF( ASSOCIATED(td_var%d_value) )THEN
-         WRITE(*,*) "ASSOCIATED"
          dl_min=MINVAL(td_var%d_value(:,:,:,:), &
          &             mask=(td_var%d_value(:,:,:,:)/=td_var%d_fill) )&
@@ -5047,30 +5455,15 @@
          &             mask=(td_var%d_value(:,:,:,:)/=td_var%d_fill) )&
          &      *td_var%d_scf+td_var%d_ofs
-      ELSE
-         WRITE(*,*) "NOT ASSOCIATED"
-         dl_min=0.
-         dl_max=0.
-      ENDIF
-
-      WRITE(*,'((a,a),3(/3x,a,a),3(/3x,a,i3),&
-      &         (/3x,a,a),5(/3x,a,ES12.4))')&
-      &        " Variable : ",TRIM(td_var%c_name),    &
-      &        " standard name : ",TRIM(td_var%c_stdname), &
-      &        " units         : ",TRIM(td_var%c_units),   &
-      &        " point         : ",TRIM(td_var%c_point),   &
-      &        " id            : ",td_var%i_id,            &
-      &        " ndim          : ",td_var%i_ndim,          &
-      &        " natt          : ",td_var%i_natt,          &
-      &        " type          : ",TRIM(cl_type),          &
-      &        " scale factor  : ",td_var%d_scf,           &
-      &        " add offset    : ",td_var%d_ofs,           &
-      &        " _FillValue    : ",td_var%d_fill,          &
-      &        " min value     : ",dl_min,                 &        
-      &        " max value     : ",dl_max
+
+         WRITE(*,'((3x,a),2(/3x,a,ES12.4))')&
+         &        "VALUE ASSOCIATED" ,       &
+         &        " min value     : ",dl_min,&        
+         &        " max value     : ",dl_max
+      ENDIF      
 
       IF( ll_more )THEN
          ! print dimension
          IF(  td_var%i_ndim /= 0 )THEN
-            WRITE(*,'(/a)') " Variable dimension"
+            WRITE(*,'(a)') " Variable dimension"
             DO ji=1,ip_maxdim
                IF( td_var%t_dim(ji)%l_use )THEN
@@ -5082,5 +5475,5 @@
          ! print attribute
          IF( td_var%i_natt /= 0 )THEN
-            WRITE(*,'(/a)') " Variable attribute"
+            WRITE(*,'(a)') " Variable attribute"
             DO ji=1,td_var%i_natt
                CALL att_print(td_var%t_att(ji))
@@ -5089,28 +5482,23 @@
       ENDIF
 
-   END SUBROUTINE var_print
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a 4D table of double value in a variable 
+   END SUBROUTINE var__print_unit
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a 4D array of real(8) value in a variable 
    !> structure.
-   !>
-   !> @warning Dimension of the table must be ordered as ('x','y','z','t')
    !
    !> @details 
    !> indices in the variable where value will be written could be specify if
-   !> start and count table are given. 
-   !
+   !> start and count array are given. 
+   !> @warning Dimension of the array must be ordered as ('x','y','z','t')
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] dd_value : table of variable value
-   !> @param[in] id_start : index in the variable from which the data values 
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_var variable structure
+   !> @param[in] dd_value  array of variable value
+   !> @param[in] id_start  index in the variable from which the data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
    SUBROUTINE var__add_value(td_var, dd_value, id_start, id_count)
       IMPLICIT NONE
@@ -5135,10 +5523,10 @@
           ((.NOT. PRESENT(id_start)) .AND.        PRESENT(id_count) ) )THEN
          CALL logger_warn( &
-         &  " ADD VALUE: id_start and id_count should be both specified")
+         &  " VAR ADD VALUE: id_start and id_count should be both specified")
       ENDIF
 
       IF( PRESENT(id_start).AND.PRESENT(id_count) )THEN
 
-         ! keep ordered table ('x','y','z','t')
+         ! keep ordered array ('x','y','z','t')
          il_start(:)=id_start(:)
          il_count(:)=id_count(:)
@@ -5146,5 +5534,5 @@
       ELSE
 
-         ! keep ordered table ('x','y','z','t')
+         ! keep ordered array ('x','y','z','t')
          il_start(:)=(/1,1,1,1/)
          il_count(:)=td_var%t_dim(:)%i_len
@@ -5152,16 +5540,16 @@
       ENDIF
 
-      ! check dimension of input table
+      ! check dimension of input array
       il_shape(:)=SHAPE(dd_value(:,:,:,:))
       IF(.NOT.ALL( il_count(:) == il_shape(:)) )THEN
-         CALL logger_error( &
-         &  " ADD VALUE: dimension of input table, and count table differ " )
 
          CALL logger_debug(" ADD VALUE: check dimension order !!")
          DO ji = 1, ip_maxdim
             CALL logger_debug( &
-            &  " ADD VALUE: count : "//TRIM(fct_str(il_count(ji)))//&
-            &  " table dimension : "//TRIM(fct_str(il_shape(ji))))
+            &  " VAR ADD VALUE: count : "//TRIM(fct_str(il_count(ji)))//&
+            &  " array dimension : "//TRIM(fct_str(il_shape(ji))))
          ENDDO
+         CALL logger_error( &
+         &  " VAR ADD VALUE: dimension of input array, and count array differ " )
 
       ELSE
@@ -5169,15 +5557,15 @@
          ! check dimension of variable
          IF(.NOT.ALL(il_start(:)+il_count(:)-1 <= td_var%t_dim(:)%i_len) )THEN
-            CALL logger_error( &
-            &  " ADD VALUE: start + count exceed variable dimension. " )
-
-            CALL logger_debug(" ADD VALUE: check dimension order !!")
+
+            CALL logger_debug(" VAR ADD VALUE: check dimension order !!")
             DO ji = 1, ip_maxdim
                CALL logger_debug( &
-               &  " ADD VALUE: start ("//TRIM(fct_str(il_start(ji)))//") "//&
+               &  " VAR ADD VALUE: start ("//TRIM(fct_str(il_start(ji)))//") "//&
                &  "+ count ("//TRIM(fct_str(il_count(ji)))//") "//&
                &  "variable dimension "//TRIM(fct_str(td_var%t_dim(ji)%i_len)))
             ENDDO
 
+            CALL logger_error( &
+            &  " VAR ADD VALUE: start + count exceed variable dimension bound. " )
          ELSE
 
@@ -5191,5 +5579,5 @@
 
                CALL logger_warn( &
-               &  " ADD VALUE: value already in variable "//&
+               &  "VAR ADD VALUE: value already in variable "//&
                &  TRIM(td_var%c_name)//&
                &  " (standard name "//TRIM(td_var%c_stdname)//")" )
@@ -5206,5 +5594,5 @@
 
                  CALL logger_error( &
-                  &  " ADD VALUE: not enough space to put variable "//&
+                  &  " VAR ADD VALUE: not enough space to put variable "//&
                   &  TRIM(td_var%c_name)//&
                   &  " in variable structure")
@@ -5212,7 +5600,7 @@
                ENDIF
                
-               ! initialise table
-               CALL logger_info( &
-               &  " ADD VALUE: value in variable "//TRIM(td_var%c_name)//&
+               ! initialise array
+               CALL logger_trace( &
+               &  " VAR ADD VALUE: value in variable "//TRIM(td_var%c_name)//&
                &  ", initialise to FillValue "//TRIM(fct_str(td_var%d_fill)) )
                td_var%d_value(:,:,:,:)=td_var%d_fill
@@ -5220,6 +5608,6 @@
             ENDIF
 
-            CALL logger_info( &
-            &  " ADD VALUE: put value in variable "//TRIM(td_var%c_name)//&
+            CALL logger_debug( &
+            &  " VAR ADD VALUE: put value in variable "//TRIM(td_var%c_name)//&
             &  " (standard name "//TRIM(td_var%c_stdname)//")" )
 
@@ -5234,32 +5622,28 @@
 
    END SUBROUTINE var__add_value
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a 4D table of real(8) value in a variable 
-   !> structure. Dimension of the table must be ordered as ('x','y','z','t')
-   !
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a 4D array of real(8) value in a variable 
+   !> structure. Dimension of the array must be ordered as ('x','y','z','t')
+   !>
    !> @details 
-   !> indices of the variable where value will be written could be specify
-   !> with start and count table.
-   !>
-   !> @note variable type is forced to DOUBLE
-   !
+   !> Optionally, you could specify the type of the variable to be used (default real(8)),
+   !> and indices of the variable where value will be written with start and count array.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] dd_value : table of variable value
-   !> @param[in] id_start : start indices of the variable where data values 
+   !> - November, 2013- Initial Version
+   !>
+   !> @param[inout] td_var variable structure
+   !> @param[in] dd_value  array of variable value
+   !> @param[in] id_type   type of the variable to be used (default real(8)) 
+   !> @param[in] id_start  start indices of the variable where data values 
    !> will be written
-   !> @param[in] id_count : number of indices selected along each dimension
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_value_dp(td_var, dd_value, id_start, id_count)
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_value_dp(td_var, dd_value, id_type, id_start, id_count)
       IMPLICIT NONE
       ! Argument      
       TYPE(TVAR),                        INTENT(INOUT) :: td_var
       REAL(dp),    DIMENSION(:,:,:,:),   INTENT(IN)    :: dd_value
+      INTEGER(i4),                       INTENT(IN),   OPTIONAL  :: id_type
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_start
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_count
@@ -5269,7 +5653,7 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_type == 0 )THEN
-         td_var%i_type=NF90_DOUBLE
-      ELSE
+      IF( PRESENT(id_type) )THEN
+         td_var%i_type=id_type
+
          cl_type=''
          SELECT CASE(td_var%i_type)
@@ -5285,5 +5669,5 @@
             cl_type='BYTE'
          END SELECT
-         CALL logger_info("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
+         CALL logger_trace("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
          &                " value will be saved as "//TRIM(cl_type)) 
       ENDIF
@@ -5292,32 +5676,28 @@
 
    END SUBROUTINE var__add_value_dp
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a 4D table of real value in a variable 
-   !> structure. Dimension of the table must be ordered as ('x','y','z','t')
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a 4D array of real(4) value in a variable 
+   !> structure. Dimension of the array must be ordered as ('x','y','z','t')
    !
    !> @details 
-   !> indices of the variable where value will be written could be specify
-   !> wiht start and count table.   
-   !>
-   !> @note variable type is forced to FLOAT
-   !
+   !> Optionally, you could specify the type of the variable to be used (default real(4)),
+   !> and indices of the variable where value will be written with start and count array.
+   !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variable structure
-   !> @param[in] rd_value : table of variable value
-   !> @param[in] id_start : start indices of the variable where data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variable structure
+   !> @param[in] rd_value  array of variable value
+   !> @param[in] id_type   type of the variable to be used (default real(4)) 
+   !> @param[in] id_start  start indices of the variable where data values 
    !> will be written
-   !> @param[in] id_count : number of indices selected along each dimension
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_value_rp(td_var, rd_value, id_start, id_count)
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_value_rp(td_var, rd_value, id_type, id_start, id_count)
       IMPLICIT NONE
       ! Argument      
       TYPE(TVAR),                        INTENT(INOUT) :: td_var
       REAL(sp),    DIMENSION(:,:,:,:),   INTENT(IN)    :: rd_value
+      INTEGER(i4),                       INTENT(IN),   OPTIONAL  :: id_type
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_start
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_count
@@ -5332,7 +5712,7 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_type == 0 )THEN
-         td_var%i_type=NF90_FLOAT
-      ELSE
+      IF( PRESENT(id_type) )THEN
+         td_var%i_type=id_type
+
          cl_type=''
          SELECT CASE(td_var%i_type)
@@ -5348,5 +5728,5 @@
             cl_type='BYTE'
          END SELECT
-         CALL logger_info("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
+         CALL logger_trace("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
          &                " value will be saved as "//TRIM(cl_type)) 
       ENDIF      
@@ -5358,5 +5738,5 @@
 
         CALL logger_error( &
-         &  " ADD VALUE: not enough space to put variable "//&
+         &  " VAR ADD VALUE: not enough space to put variable "//&
          &  TRIM(td_var%c_name)//&
          &  " in variable structure")
@@ -5370,32 +5750,30 @@
 
    END SUBROUTINE var__add_value_rp
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a 4D table of integer(1) value in a variable 
-   !> structure. Dimension of the table must be ordered as ('x','y','z','t')
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a 4D array of integer(1) value in a variable 
+   !> structure. Dimension of the array must be ordered as ('x','y','z','t')
    !
    !> @details 
-   !> indices in the variable where value will be written could be specify if
-   !> start and count table are given.   
+   !> Optionally, you could specify the type of the variable to be used (default integer(1)),
+   !> and indices of the variable where value will be written with start and count array.
    !>
    !> @note variable type is forced to BYTE
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variabele structure
-   !> @param[in] bd_value : table of variable value
-   !> @param[in] id_start : start indices of the variable where data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variabele structure
+   !> @param[in] bd_value  array of variable value
+   !> @param[in] id_type   type of the variable to be used (default integer(1)) 
+   !> @param[in] id_start  start indices of the variable where data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_value_i1(td_var, bd_value, id_start, id_count)
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_value_i1(td_var, bd_value, id_type, id_start, id_count)
       IMPLICIT NONE
       ! Argument      
       TYPE(TVAR),                        INTENT(INOUT) :: td_var
       INTEGER(i1), DIMENSION(:,:,:,:),   INTENT(IN)    :: bd_value
+      INTEGER(i4),                       INTENT(IN),   OPTIONAL  :: id_type
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_start
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_count
@@ -5410,7 +5788,7 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_type == 0 )THEN
-         td_var%i_type=NF90_BYTE
-      ELSE
+      IF( PRESENT(id_type) )THEN
+         td_var%i_type=id_type
+
          cl_type=''
          SELECT CASE(td_var%i_type)
@@ -5426,5 +5804,5 @@
             cl_type='BYTE'
          END SELECT
-         CALL logger_info("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
+         CALL logger_trace("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
          &                " value will be saved as "//TRIM(cl_type)) 
       ENDIF
@@ -5436,5 +5814,5 @@
 
         CALL logger_error( &
-         &  " ADD VALUE: not enough space to put variable "//&
+         &  " VAR ADD VALUE: not enough space to put variable "//&
          &  TRIM(td_var%c_name)//&
          &  " in variable structure")
@@ -5448,32 +5826,30 @@
 
    END SUBROUTINE var__add_value_i1
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a 4D table of integer(1) value in a variable 
-   !> structure. Dimension of the table must be ordered as ('x','y','z','t')
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a 4D array of integer(2) value in a variable 
+   !> structure. Dimension of the array must be ordered as ('x','y','z','t')
    !
    !> @details 
-   !> indices in the variable where value will be written could be specify if
-   !> start and count table are given.   
+   !> Optionally, you could specify the type of the variable to be used (default integer(2)),
+   !> and indices of the variable where value will be written with start and count array.
    !>
    !> @note variable type is forced to SHORT
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variabele structure
-   !> @param[in] sd_value : table of variable value
-   !> @param[in] id_start : start indices of the variable where data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variabele structure
+   !> @param[in] sd_value  array of variable value
+   !> @param[in] id_type   type of the variable to be used (default integer(2)) 
+   !> @param[in] id_start  start indices of the variable where data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_value_i2(td_var, sd_value, id_start, id_count)
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_value_i2(td_var, sd_value, id_type, id_start, id_count)
       IMPLICIT NONE
       ! Argument      
       TYPE(TVAR),                        INTENT(INOUT) :: td_var
       INTEGER(i2), DIMENSION(:,:,:,:),   INTENT(IN)    :: sd_value
+      INTEGER(i4),                       INTENT(IN),   OPTIONAL  :: id_type
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_start
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_count
@@ -5488,7 +5864,7 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_type == 0 )THEN
-         td_var%i_type=NF90_SHORT
-      ELSE
+      IF( PRESENT(id_type) )THEN
+         td_var%i_type=id_type
+
          cl_type=''
          SELECT CASE(td_var%i_type)
@@ -5504,5 +5880,5 @@
             cl_type='BYTE'
          END SELECT
-         CALL logger_info("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
+         CALL logger_trace("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
          &                " value will be saved as "//TRIM(cl_type)) 
       ENDIF
@@ -5514,5 +5890,5 @@
 
         CALL logger_error( &
-         &  " ADD VALUE: not enough space to put variable "//&
+         &  " VAR ADD VALUE: not enough space to put variable "//&
          &  TRIM(td_var%c_name)//&
          &  " in variable structure")
@@ -5526,32 +5902,30 @@
 
    END SUBROUTINE var__add_value_i2
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine add a 4D table of integer(4) value in a variable 
-   !> structure. Dimension of the table must be ordered as ('x','y','z','t')
+   !-------------------------------------------------------------------
+   !> @brief This subroutine add a 4D array of integer(4) value in a variable 
+   !> structure. Dimension of the array must be ordered as ('x','y','z','t')
    !
    !> @details 
-   !> indices in the variable where value will be written could be specify if
-   !> start and count table are given.   
+   !> Optionally, you could specify the type of the variable to be used (default integer(4)),
+   !> and indices of the variable where value will be written with start and count array.
    !>
    !> @note variable type is forced to INT
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_var : variabele structure
-   !> @param[in] id_value : table of variable value
-   !> @param[in] id_start : start indices of the variable where data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_var variabele structure
+   !> @param[in] id_value  array of variable value
+   !> @param[in] id_type   type of the variable to be used (default integer(4)) 
+   !> @param[in] id_start  start indices of the variable where data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !
-   !> @todo 
-   !-------------------------------------------------------------------
-   !> @code
-   SUBROUTINE var__add_value_i4(td_var, id_value, id_start, id_count)
+   !> @param[in] id_count  number of indices selected along each dimension
+   !-------------------------------------------------------------------
+   SUBROUTINE var__add_value_i4(td_var, id_value, id_type, id_start, id_count)
       IMPLICIT NONE
       ! Argument      
       TYPE(TVAR),                        INTENT(INOUT) :: td_var
       INTEGER(i4), DIMENSION(:,:,:,:),   INTENT(IN)    :: id_value
+      INTEGER(i4),                       INTENT(IN),   OPTIONAL  :: id_type
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_start
       INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN),   OPTIONAL  :: id_count
@@ -5566,7 +5940,7 @@
       !----------------------------------------------------------------
 
-      IF( td_var%i_type == 0 )THEN
-         td_var%i_type=NF90_INT
-      ELSE
+      IF( PRESENT(id_type) )THEN
+         td_var%i_type=id_type
+
          cl_type=''
          SELECT CASE(td_var%i_type)
@@ -5582,5 +5956,5 @@
             cl_type='BYTE'
          END SELECT
-         CALL logger_info("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
+         CALL logger_trace("VAR ADD VALUE: "//TRIM(td_var%c_name)//&
          &                " value will be saved as "//TRIM(cl_type)) 
       ENDIF
@@ -5592,5 +5966,5 @@
 
         CALL logger_error( &
-         &  " ADD VALUE: not enough space to put variable "//&
+         &  " VAR ADD VALUE: not enough space to put variable "//&
          &  TRIM(td_var%c_name)//&
          &  " in variable structure")
